DROP TABLESPACE WBPMSPACE1;
DROP BUFFERPOOL IBMWBPMBP;
CREATE BUFFERPOOL IBMWBPMBP IMMEDIATE  SIZE 250 PAGESIZE 16 K ;

---------------------------------------------------------------------------------------------------------
-- Create Table Space
-- Only for windows system now.
---------------------------------------------------------------------------------------------------------

CREATE  REGULAR  TABLESPACE WBPMSPACE1 PAGESIZE 16 K  MANAGED BY SYSTEM  
USING ('@DBSCHEMA@') 
EXTENTSIZE 16 
BUFFERPOOL  IBMWBPMBP  
DROPPED TABLE RECOVERY OFF;
---------------------------------------------------------------------------------------------------------
-- Create Table
---------------------------------------------------------------------------------------------------------

CREATE TABLE @DBSCHEMA@.Perspective (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Name VARCHAR(256) NOT NULL,
        Description VARCHAR(1024),
        Parent_OID BIGINT DEFAULT NULL
);

CREATE TABLE @DBSCHEMA@.AuditTrail (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Owner_OID BIGINT,
        AUDIT_ACTION VARCHAR(32),
        ResourceType SMALLINT,
        Subject_OID BIGINT NOT NULL,
        New_Value VARCHAR(1024),
        Old_Value VARCHAR(1024),
        Field_Name VARCHAR(1024),
        Aux_OID BIGINT,
        Aux_INFO VARCHAR(1024)
) IN WBPMSPACE1;

CREATE TABLE @DBSCHEMA@.Scorecard (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Owner_OID BIGINT NOT NULL,
        Name VARCHAR(256) DEFAULT NULL,
        IsGroup SMALLINT DEFAULT 0,
        Category_OID BIGINT DEFAULT NULL,
        Summary VARCHAR(1024) DEFAULT NULL,
        To_Be_Deleted SMALLINT DEFAULT 0    
);

CREATE TABLE @DBSCHEMA@.DataSource (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Name VARCHAR(256) NOT NULL,
        Description VARCHAR(1024),
        WSDL VARCHAR(1024),
        httpConfig VARCHAR(256),
        requestConfig VARCHAR(256),
        responseConfig VARCHAR(256),        
        Source_Attributes Blob
);

CREATE TABLE @DBSCHEMA@.DataSourceInstance (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        DataSource_OID BIGINT NOT NULL,
        Instance_Attributes Blob
);

CREATE TABLE @DBSCHEMA@.Label (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Label_Key VARCHAR(128),
        Locale CHAR(5),
        Value VARCHAR(1024),
        DefaultValue VARCHAR(1024)
);

CREATE TABLE @DBSCHEMA@.Alert (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Alert_Type SMALLINT DEFAULT 1,
        OWNER_OID BIGINT,
        Msg_Key VARCHAR(64),
        Msg_Parameter_Values VARCHAR(1024),
        Subject_Key VARCHAR(64),
        Subject_Parameter_Values VARCHAR(512),
        State SMALLINT NOT NULL,
        ResourceType SMALLINT NOT NULL,
        Resource_OID BIGINT NOT NULL,
        ResourceOwner_OID BIGINT NOT NULL,
        Pending_Email	BIGINT
);

CREATE TABLE @DBSCHEMA@.Principal (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        ExtUser VARCHAR(256) NOT NULL
);

CREATE TABLE @DBSCHEMA@.Hierarchy (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Attribute_Hierachy VARCHAR(254),
        Attribute_Unit_Name VARCHAR(254),
        Image_Small VARCHAR(256),
        Image_Large VARCHAR(256),
        Label_KEY VARCHAR(128),
        IsPrimary SMALLINT,
        Ordinal SMALLINT,
        Read_From SMALLINT DEFAULT 0,
        Attribute_Leaf_Unit_Name VARCHAR(254)
);

CREATE TABLE @DBSCHEMA@.UserAttribute (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Attribute VARCHAR(254),
        Label_KEY VARCHAR(128),
        Ordinal SMALLINT
);

CREATE TABLE @DBSCHEMA@.Execution(
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        To_Be_Deleted SMALLINT,
        Scorecard_OID BIGINT NOT NULL,
        Perspective_OID BIGINT,
        DataSource_Instance_OID BIGINT,
        Value_Type SMALLINT NOT NULL,
        RollUp_Type SMALLINT NOT NULL,
        Name VARCHAR(256) NOT NULL,
        Summary VARCHAR(1024),
        Mark SMALLINT DEFAULT -1,
        Actual DOUBLE DEFAULT -1,
        ActionTime BIGINT,
        Last_Alerted_Trend SMALLINT DEFAULT -1,
        Last_Alerted_Status SMALLINT DEFAULT -1,
        Milestone SMALLINT,
        Last_Alerted_MileStone BIGINT,
        Start_Time BIGINT DEFAULT -1,
        Completion_Time BIGINT NOT NULL,
        Resource_Type SMALLINT,
        Has_TARGET SMALLINT,
        STATE SMALLINT DEFAULT 1
);

CREATE TABLE @DBSCHEMA@.ExecutionMeasurement (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        EXECUTION_OID BIGINT ,
        Ordinal SMALLINT,
        ActionTime BIGINT,
        TARGETVALUE Double
);

CREATE TABLE @DBSCHEMA@.ExecutionStatus (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        EXECUTION_OID BIGINT NOT NULL,
        Status_Color SMALLINT,
        Status_Zone SMALLINT
);

CREATE TABLE @DBSCHEMA@.ExecutionLinkage (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	Execution_OID BIGINT,
	Relationship VARCHAR(2048),
	Relationship_Type SMALLINT,
	Start_Time BIGINT,
	Completion_Time BIGINT,
	Link_Type SMALLINT,
	To_Be_Deleted SMALLINT,
    Rollup_time BIGINT 
);

CREATE TABLE @DBSCHEMA@.ExecutionAssociation (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	From_OID BIGINT,
	To_OID BIGINT,
	Link_Type SMALLINT
);

CREATE TABLE @DBSCHEMA@.ExecutionValue (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        EXECUTION_OID BIGINT NOT NULL,
        ActionTime BIGINT DEFAULT -1,
        Actual DOUBLE DEFAULT -1
);

-- change Category to Category_OID
CREATE TABLE @DBSCHEMA@.MeasurementTemplate (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	Name VARCHAR(256),
	Description VARCHAR(1024),
	Category_OID BIGINT
);

-- add one more table for Measurement Template Category

CREATE TABLE @DBSCHEMA@.MeasurementTemplateCategory (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	Name VARCHAR(512) NOT NULL,
	Description VARCHAR(1024)
);


CREATE TABLE @DBSCHEMA@.MeasurementTemplateValue (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	MT_OID BIGINT,
	ORDINAL SMALLINT,
	TIMEUNIT SMALLINT,
	FORMULA VARCHAR(512)
);

CREATE TABLE @DBSCHEMA@.MeasurementTemplateStatus (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	MT_OID BIGINT,
	MT_COLOR SMALLINT,
	MT_ZONE SMALLINT
);

CREATE TABLE @DBSCHEMA@.ScheduleActionTime (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Action_Time BIGINT,
        Status SMALLINT,
        CountNum BIGINT,
        RollUpTime BIGINT
);

CREATE TABLE @DBSCHEMA@.WebResource (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        EXECUTION_OID BIGINT NOT NULL,
        Resource_Name VARCHAR(256),
        URL VARCHAR(1024),
        Type SMALLINT,
        Display_Type SMALLINT,
        Favorite SMALLINT
);

CREATE TABLE @DBSCHEMA@.GlobalSetting (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        SETTINGKEY VARCHAR(32),
        Value VARCHAR(256)
);

CREATE TABLE @DBSCHEMA@.WBPM_ID_TABLE (
        RES_TYPE SMALLINT NOT NULL,
        LAST_OID BIGINT NOT NULL,
        LOCAL_PID INTEGER
);

CREATE TABLE @DBSCHEMA@.WBPM_GUPID_DESC (
        LOCAL_PID INTEGER DEFAULT 0 NOT NULL,
        GUPID CHAR(20) NOT NULL,
        STATE CHAR(1) DEFAULT 'O' NOT NULL
);

CREATE TABLE @DBSCHEMA@.Actn (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Action_Name VARCHAR(64) NOT NULL,
        Description VARCHAR(1024)
        );

CREATE TABLE @DBSCHEMA@.ActionSet (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Action_Set_Name VARCHAR(256) NOT NULL,
        Description VARCHAR(1024)
        );

CREATE TABLE @DBSCHEMA@.ActionSetAction (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Action_Set_OID BIGINT,
        Action_OID BIGINT
        );

CREATE TABLE @DBSCHEMA@.ActionResourceType (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Resource_Type SMALLINT,
        Action_OID  BIGINT
        );

CREATE TABLE @DBSCHEMA@.ResourcePolicy (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Resource_Type SMALLINT NOT NULL,
        Action_Set_OID BIGINT NOT NULL,
        Start_Level SMALLINT,
        End_Level SMALLINT
        );

CREATE TABLE @DBSCHEMA@.ResourceInstancePolicy (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Resource_Type SMALLINT NOT NULL,
        Resource_OID BIGINT NOT NULL,
        Action_Set_OID BIGINT NOT NULL,
        Start_Level SMALLINT,
        End_Level SMALLINT
        );

CREATE TABLE @DBSCHEMA@.ResourceUserPolicy (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Operation SMALLINT,
        USER_ID BIGINT NOT NULL,
        Action_Set_OID BIGINT NOT NULL,
        Resource_Type SMALLINT NOT NULL
        );

CREATE TABLE @DBSCHEMA@.ResourceInstanceUserPolicy (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Operation SMALLINT,
        USER_ID BIGINT NOT NULL,
        Action_Set_OID BIGINT NOT NULL,
        Resource_OID BIGINT NOT NULL,
    	Resource_Type SMALLINT NOT NULL
        );

CREATE TABLE @DBSCHEMA@.Task (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	Name VARCHAR(256) NOT NULL,
	Class VARCHAR(512),
	Type SMALLINT
);

CREATE TABLE @DBSCHEMA@.AsyncEvent (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	WASTaskID BIGINT,
	Name VARCHAR(128),
	Class VARCHAR(128),
	Status SMALLINT,
	Freq SMALLINT,
	LastStartDate BIGINT,
	LastEndDate BIGINT,
	Stop SMALLINT,
	Updated BIGINT,
	CurrentTask VARCHAR(512),
	Success SMALLINT,
	Independence SMALLINT
);

CREATE TABLE @DBSCHEMA@.EventTask (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	AsyncEvent_OID BIGINT,
	Task_OID BIGINT,
	Param VARCHAR(1024),
	Ordinal SMALLINT,
	LastStartDate BIGINT,
	LastEndDate BIGINT,
	Stop SMALLINT,
	Updated BIGINT,
	Message VARCHAR(512)
);

CREATE TABLE @DBSCHEMA@.TaskLog (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	EventTask_OID BIGINT,
	Progress DOUBLE,
	StartDate BIGINT,
	EndDate BIGINT,
	Status SMALLINT,
	Message VARCHAR(512)
);


CREATE TABLE @DBSCHEMA@.TaskLogDetail (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	TaskLog_OID BIGINT,
	Message VARCHAR(1024)
);

CREATE TABLE @DBSCHEMA@.SecurityConf (
	OID BIGINT NOT NULL,
	Created BIGINT NOT NULL,
	Modified BIGINT DEFAULT NULL,
	Name VARCHAR(256),
	Description VARCHAR(1024),
	Conf_Attr BLOB,
	SecurityConf_Type SMALLINT
);

CREATE TABLE @DBSCHEMA@.ExecutionShare (
        OID           BIGINT NOT NULL,
        Created       BIGINT NOT NULL,
        Modified      BIGINT DEFAULT NULL,
        Execution_OID BIGINT NOT NULL,
        Scorecard_OID BIGINT NOT NULL
);
CREATE TABLE @DBSCHEMA@.ScorecardCategory (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Name VARCHAR(256) NOT NULL,
        Parent_OID BIGINT DEFAULT NULL
);
CREATE TABLE @DBSCHEMA@.ExecutionCategory (
        OID        BIGINT NOT NULL,
        Created    BIGINT NOT NULL,
        Modified   BIGINT DEFAULT NULL,
        Name       VARCHAR(256) NOT NULL,
        Owner_OID  BIGINT NOT NULL,
        Parent_OID BIGINT DEFAULT NULL
);

CREATE TABLE @DBSCHEMA@.ExecutionCategoryAssociation (
        OID           BIGINT NOT NULL,
        Created       BIGINT NOT NULL,
        Modified      BIGINT DEFAULT NULL,
        Execution_OID BIGINT NOT NULL,
        Category_OID  BIGINT NOT NULL
);

CREATE TABLE @DBSCHEMA@.FavoriteScorecard (
        OID BIGINT NOT NULL,
        Created BIGINT NOT NULL,
        Modified BIGINT DEFAULT NULL,
        Owner_OID BIGINT NOT NULL,
        Scorecard_OID BIGINT DEFAULT NOT NULL
);
-------------------------------------------------------------------------------------

CREATE TABLE @DBSCHEMA@.LWPTASK
(
          "TASKID"                     BIGINT             NOT NULL ,
          "VERSION"                    VARCHAR(5)         NOT NULL ,
          "ROW_VERSION"                INTEGER            NOT NULL ,
          "TASKTYPE"                   INTEGER            NOT NULL ,
          "TASKSUSPENDED"              SMALLINT           NOT NULL ,
          "CANCELLED"                  SMALLINT           NOT NULL ,
          "NEXTFIRETIME"               BIGINT             NOT NULL ,
          "STARTBYINTERVAL"            VARCHAR(254)        ,
          "STARTBYTIME"                BIGINT              ,
          "VALIDFROMTIME"              BIGINT              ,
          "VALIDTOTIME"                BIGINT              ,
          "REPEATINTERVAL"             VARCHAR(254)        ,
          "MAXREPEATS"                 INTEGER            NOT NULL ,
          "REPEATSLEFT"                INTEGER            NOT NULL ,
          "TASKINFO"                   BLOB(102400)       LOGGED NOT COMPACT ,
          "NAME"                       VARCHAR(254)       NOT NULL ,
          "AUTOPURGE"                  INTEGER            NOT NULL ,
          "FAILUREACTION"              INTEGER             ,
          "MAXATTEMPTS"                INTEGER             ,
          "QOS"                        INTEGER             ,
          "PARTITIONID"                INTEGER             ,
      "OWNERTOKEN"                 VARCHAR(200)       NOT NULL ,
          "CREATETIME"                 BIGINT             NOT NULL
);

ALTER TABLE @DBSCHEMA@.LWPTASK
        ADD PRIMARY KEY
                ("TASKID");

CREATE INDEX "LWPTASK_IDX1"
  ON @DBSCHEMA@.LWPTASK
(
    "TASKID","OWNERTOKEN"
);


CREATE INDEX "LWPTASK_IDX2"
  ON @DBSCHEMA@.LWPTASK
(
    "NEXTFIRETIME" ASC, "REPEATSLEFT", "PARTITIONID"
) CLUSTER;

CREATE TABLE @DBSCHEMA@.LWPTREG
(
    "REGKEY"                       VARCHAR(254)         NOT NULL ,
    "REGVALUE"                     VARCHAR(254)
);

ALTER TABLE @DBSCHEMA@.LWPTREG
        ADD PRIMARY KEY
                ("REGKEY");

-- Lease Manager
CREATE TABLE @DBSCHEMA@.LWPLMGR
(
        LEASENAME                      VARCHAR(254) NOT NULL,
        LEASEOWNER                     VARCHAR(254) NOT NULL,
        LEASE_EXPIRE_TIME              BIGINT,
        DISABLED                       VARCHAR(5)
);

ALTER TABLE @DBSCHEMA@.LWPLMGR
        ADD PRIMARY KEY
                ("LEASENAME");

CREATE TABLE @DBSCHEMA@.LWPLMPR
(
        LEASENAME                      VARCHAR(254) NOT NULL,
        NAME                           VARCHAR(254) NOT NULL,
        VALUE                          VARCHAR(254) NOT NULL
);

CREATE INDEX "LWPLMPR_IDX1" ON @DBSCHEMA@.LWPLMPR
(
        LEASENAME, NAME
);


---------------------------------------------------------------------------------------------------------
-- Define Primary Key
---------------------------------------------------------------------------------------------------------

ALTER TABLE @DBSCHEMA@.Perspective
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.AuditTrail
        ADD PRIMARY KEY(
                OID
                )
;

ALTER TABLE @DBSCHEMA@.Scorecard
        ADD PRIMARY KEY (
                OID
                )
;


--- add unique constr. on execution with (name, scorecard_oid, completion_time) by zhouzhen 20060629
ALTER TABLE @DBSCHEMA@.Execution
        ADD UNIQUE (
                Name,
                Scorecard_OID,
                Completion_Time
                )
;

ALTER TABLE @DBSCHEMA@.DataSource
        ADD PRIMARY KEY (
                OID
                )
;


ALTER TABLE @DBSCHEMA@.DataSourceInstance
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.Label
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.Alert
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.Principal
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.Principal
        ADD UNIQUE (
                ExtUser
                )
;

ALTER TABLE @DBSCHEMA@.Hierarchy
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.UserAttribute
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.Execution
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ExecutionMeasurement
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ExecutionStatus
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ExecutionLinkage
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.ExecutionAssociation
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.ExecutionValue
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.MeasurementTemplate
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.MeasurementTemplateValue 
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.MeasurementTemplateStatus
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.ScheduleActionTime
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.WebResource
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.GlobalSetting
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.WBPM_ID_TABLE
        ADD PRIMARY KEY (
                RES_TYPE
                )
;

ALTER TABLE @DBSCHEMA@.Actn
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ActionSet
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ActionSetAction
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ActionResourceType
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ResourcePolicy
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ResourceInstancePolicy
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ResourceUserPolicy
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.ResourceInstanceUserPolicy
        ADD PRIMARY KEY (
                OID
                )
;

ALTER TABLE @DBSCHEMA@.Task
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.Task
        ADD UNIQUE (
                Name
                )
;

ALTER TABLE @DBSCHEMA@.AsyncEvent
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.EventTask
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.TaskLog
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.TaskLogDetail
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.SecurityConf
	ADD PRIMARY KEY (
		OID
	)
;

-- Added by ShaoYongZhen on 20060320
ALTER TABLE @DBSCHEMA@.MeasurementTemplateCategory
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.ExecutionShare
	ADD PRIMARY KEY (
    	OID
	)
;

ALTER TABLE @DBSCHEMA@.ExecutionCategory
	ADD PRIMARY KEY (
		OID
	)
;

ALTER TABLE @DBSCHEMA@.ExecutionCategoryAssociation
	ADD PRIMARY KEY (
		OID
	)
;


ALTER TABLE @DBSCHEMA@.FavoriteScorecard
        ADD PRIMARY KEY (
                OID
                )
;

---------------------------------------------------------------------------------------------------------
-- Create Foreign Key
---------------------------------------------------------------------------------------------------------

ALTER TABLE @DBSCHEMA@.Perspective
        ADD FOREIGN KEY (
                Parent_OID
                )
        REFERENCES @DBSCHEMA@.Perspective (
                OID
                )
        NOT ENFORCED
;


ALTER TABLE @DBSCHEMA@.DataSourceInstance
        ADD FOREIGN KEY (
                DataSource_OID
                )
        REFERENCES @DBSCHEMA@.DataSource (
                OID
                )
        NOT ENFORCED
;


ALTER TABLE @DBSCHEMA@.Execution
        ADD FOREIGN KEY (
                Scorecard_OID
                )
        REFERENCES @DBSCHEMA@.Scorecard (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.Execution
        ADD FOREIGN KEY (
                Perspective_OID
                )
        REFERENCES @DBSCHEMA@.Perspective (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.Execution
        ADD FOREIGN KEY (
                DataSource_Instance_OID
                )
        REFERENCES @DBSCHEMA@.DataSourceInstance (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ExecutionMeasurement
	ADD FOREIGN KEY (
		EXECUTION_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
		OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ExecutionStatus
        ADD FOREIGN KEY (
                EXECUTION_OID
                )
        REFERENCES @DBSCHEMA@.Execution (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ExecutionLinkage
	ADD FOREIGN KEY (
		Execution_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
		OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ExecutionAssociation
	ADD FOREIGN KEY (
		From_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
		OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ExecutionValue
        ADD FOREIGN KEY (
                EXECUTION_OID
                )
        REFERENCES @DBSCHEMA@.Execution (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.MeasurementTemplateValue 
	ADD FOREIGN KEY (
		MT_OID
	)
	REFERENCES @DBSCHEMA@.MeasurementTemplate (
		OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.MeasurementTemplateStatus 
	ADD FOREIGN KEY (
		MT_OID
	)
	REFERENCES @DBSCHEMA@.MeasurementTemplate (
		OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.WebResource
        ADD FOREIGN KEY (
                EXECUTION_OID
                )
        REFERENCES @DBSCHEMA@.Execution (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ActionSetAction
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ActionSetAction
        ADD FOREIGN KEY (
                Action_OID
                )
        REFERENCES @DBSCHEMA@.Actn (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ActionResourceType
        ADD FOREIGN KEY (
                Action_OID
                )
        REFERENCES @DBSCHEMA@.Actn (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ResourcePolicy
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ResourcePolicy
        ADD UNIQUE (
                Resource_Type, Action_Set_OID
                )
;

ALTER TABLE @DBSCHEMA@.ResourceInstancePolicy
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ResourceInstancePolicy
        ADD UNIQUE (
                Resource_Type, Resource_OID, Action_Set_OID
                )
;

ALTER TABLE @DBSCHEMA@.ResourceUserPolicy
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                )
        NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ResourceUserPolicy
        ADD UNIQUE (
                USER_ID, Action_Set_OID, Resource_Type
                )
;

ALTER TABLE @DBSCHEMA@.ResourceInstanceUserPolicy
        ADD UNIQUE (
                USER_ID, Action_Set_OID, Resource_OID, Resource_Type
                )
;

ALTER TABLE @DBSCHEMA@.ResourceInstanceUserPolicy
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                )
        NOT ENFORCED
;


ALTER TABLE @DBSCHEMA@.EventTask
	ADD FOREIGN KEY (
		AsyncEvent_OID
	)
	REFERENCES @DBSCHEMA@.AsyncEvent (
		OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.EventTask
	ADD FOREIGN KEY (
		Task_OID
	)
	REFERENCES @DBSCHEMA@.Task (
		OID
	)
	NOT ENFORCED
;


ALTER TABLE @DBSCHEMA@.TaskLog
	ADD FOREIGN KEY (
		EventTask_OID
	)
	REFERENCES @DBSCHEMA@.EventTask (
		OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.TaskLogDetail
	ADD FOREIGN KEY (
		TaskLog_OID
	)
	REFERENCES @DBSCHEMA@.TaskLog (
		OID
	)
	NOT ENFORCED
;

-- Added by ShaoYongZhen on 20060320
ALTER TABLE @DBSCHEMA@.MeasurementTemplate
	ADD FOREIGN KEY (
		Category_OID
	)
	REFERENCES @DBSCHEMA@.MeasurementTemplateCategory (
		OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.MeasurementTemplateCategory
	ADD UNIQUE (
		Name
	)
;
-- Added by M.Young on 20070502
ALTER TABLE @DBSCHEMA@.ScorecardCategory
	ADD PRIMARY KEY (
		OID
	)

;

ALTER TABLE @DBSCHEMA@.ExecutionShare
	ADD FOREIGN KEY (
		Scorecard_OID
	)
	REFERENCES @DBSCHEMA@.Scorecard (
    	OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ExecutionShare
	ADD FOREIGN KEY (
    	Execution_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
    	OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ExecutionCategoryAssociation
	ADD FOREIGN KEY (
    	Execution_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
    	OID
	)
	NOT ENFORCED
;

ALTER TABLE @DBSCHEMA@.ExecutionCategoryAssociation
	ADD FOREIGN KEY (
    	Category_OID
	)
	REFERENCES @DBSCHEMA@.ExecutionCategory (
    	OID
	)
	NOT ENFORCED
;

---------------------------------------------------------------------------------------------------------
-- Create Index
---------------------------------------------------------------------------------------------------------

CREATE INDEX @DBSCHEMA@.ALERT_IDX1 ON @DBSCHEMA@.ALERT (
      ALERT_TYPE, 
      OWNER_OID);

CREATE INDEX ALERT_IDX2 ON @DBSCHEMA@.ALERT (
      OWNER_OID);

CREATE INDEX AUDITRAIL_IDX1 ON @DBSCHEMA@.AUDITTRAIL (
      OWNER_OID) ;

CREATE INDEX AUDITTRAIL_IDX2 ON @DBSCHEMA@.AUDITTRAIL (
      RESOURCETYPE, 
      SUBJECT_OID);
      
CREATE INDEX DSI_IDX ON @DBSCHEMA@.DATASOURCEINSTANCE (
      DATASOURCE_OID);
      
CREATE  INDEX @DBSCHEMA@.EXE_IDX1 ON @DBSCHEMA@.EXECUTION (
      SCORECARD_OID);

CREATE  INDEX @DBSCHEMA@.EXE_IDX2 ON @DBSCHEMA@.EXECUTION (
      RESOURCE_TYPE);

CREATE  INDEX @DBSCHEMA@.EXE_IDX3 ON @DBSCHEMA@.EXECUTION (
      START_TIME);

CREATE  INDEX EXE_IDX4 ON @DBSCHEMA@.EXECUTION (
      SCORECARD_OID, PERSPECTIVE_OID);
      
CREATE  INDEX EXE_IDX5 ON @DBSCHEMA@.EXECUTION (
      SCORECARD_OID, NAME);
      

CREATE  INDEX EXE_IDX ON @DBSCHEMA@.EXECUTION (
      DATASOURCE_INSTANCE_OID);

CREATE  INDEX LINKAGE_IDX1 ON @DBSCHEMA@.EXECUTIONLINKAGE (
      EXECUTION_OID);

CREATE  INDEX LINKAGE_IDX2 ON @DBSCHEMA@.EXECUTIONLINKAGE (
      TO_BE_DELETED);

CREATE  INDEX LINKAGE_IDX3 ON @DBSCHEMA@.EXECUTIONLINKAGE (
      LINK_TYPE);
      
CREATE  INDEX LINKAGE_IDX4 ON @DBSCHEMA@.EXECUTIONLINKAGE (
      EXECUTION_OID, RELATIONSHIP_TYPE);      

CREATE  INDEX LINKAGE_IDX5 ON @DBSCHEMA@.EXECUTIONLINKAGE (
      EXECUTION_OID, START_TIME, COMPLETION_TIME);
      
            
CREATE  INDEX MEA_IDX2 ON @DBSCHEMA@.EXECUTIONMEASUREMENT (
      EXECUTION_OID);
            
CREATE  INDEX @DBSCHEMA@.STATUS_IDX1 ON @DBSCHEMA@.EXECUTIONSTATUS (
      EXECUTION_OID);
      
CREATE  INDEX @DBSCHEMA@.VALUE_IDX1 ON @DBSCHEMA@.EXECUTIONVALUE (
      EXECUTION_OID);

           
CREATE  INDEX RIP_IDX1 ON @DBSCHEMA@.RESOURCEINSTANCEPOLICY (
      ACTION_SET_OID);

CREATE  INDEX RIP_IDX2 ON @DBSCHEMA@.RESOURCEINSTANCEPOLICY (
      RESOURCE_TYPE, 
      RESOURCE_OID);  
      
CREATE  INDEX RIUP_IDX1 ON @DBSCHEMA@.RESOURCEINSTANCEUSERPOLICY (
      USER_ID) ;

CREATE  INDEX RIUP_IDX2 ON @DBSCHEMA@.RESOURCEINSTANCEUSERPOLICY (
      ACTION_SET_OID);

CREATE  INDEX RIUP_IDX3 ON @DBSCHEMA@.RESOURCEINSTANCEUSERPOLICY (
      RESOURCE_OID, 
      RESOURCE_TYPE);
      
CREATE  INDEX WEBRESOURCE_IDX ON @DBSCHEMA@.WEBRESOURCE (
      EXECUTION_OID);
           
CREATE  INDEX ASSOCIATION_IDX1 ON @DBSCHEMA@.EXECUTIONASSOCIATION (
      FROM_OID);
      
CREATE  INDEX ASSOCIATION_IDX2 ON @DBSCHEMA@.EXECUTIONASSOCIATION (
      FROM_OID, LINK_TYPE);
      
CREATE  INDEX ASSOCIATION_IDX3 ON @DBSCHEMA@.EXECUTIONASSOCIATION (
      TO_OID, LINK_TYPE);
      
CREATE  INDEX ASYNCEVENT_IDX1 ON @DBSCHEMA@.ASYNCEVENT (
      WASTaskID);
      
CREATE INDEX ES_IDX1 ON @DBSCHEMA@.ExecutionShare (
      Scorecard_OID);

CREATE INDEX ES_IDX2 ON @DBSCHEMA@.ExecutionShare (
      Execution_OID);

CREATE INDEX EC_IDX1 ON @DBSCHEMA@.ExecutionCategory (
      Owner_OID);

CREATE INDEX ECA_IDX1 ON @DBSCHEMA@.ExecutionCategoryAssociation (
      Execution_OID);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX1 ON @DBSCHEMA@.SCORECARD (
      IsGroup,
      To_Be_Deleted);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX2 ON @DBSCHEMA@.SCORECARD (
      IsGroup,
      name);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX3 ON @DBSCHEMA@.SCORECARD (
      IsGroup,
      Owner_OID);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX4 ON @DBSCHEMA@.SCORECARD (
      Owner_OID);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX5 ON @DBSCHEMA@.SCORECARD (
      Category_OID);



-----------------------------------------------------------------------------
-- ANNOTATION_IDSEQ
-----------------------------------------------------------------------------
DROP SEQUENCE @DBSCHEMA@.IBMAN_IDSEQ RESTRICT;
 
CREATE SEQUENCE @DBSCHEMA@.IBMAN_IDSEQ
	AS BIGINT
	START WITH 1
	INCREMENT BY 1
	MINVALUE 1
	NO MAXVALUE
	NO CYCLE
	NO CACHE
	NO ORDER;
	
-----------------------------------------------------------------------------
-- ANNOTATION
-----------------------------------------------------------------------------

DROP TABLE @DBSCHEMA@.IBMAN_ANNOTATION;

 
CREATE TABLE @DBSCHEMA@.IBMAN_ANNOTATION (
		  "ID" BIGINT NOT NULL , 
		  "ANNOTATIONID" VARCHAR(512) NOT NULL , 
		  "CONTENT" CLOB(32768), 
		  "AUTHOR" VARCHAR(256) NOT NULL , 
		  "PARENT" BIGINT , 
		  "TITLE" VARCHAR(1024), 
		  "TABLEID" VARCHAR(512) , 
		  "TYPE" INTEGER , 
		  "ATTACHMENTSDIR" VARCHAR(256) , 
		  "ENABLEPRIVACY" INTEGER NOT NULL WITH DEFAULT 0 , 
		  "CREATEDDATE" BIGINT NOT NULL ,
		  "LASTMODIFIEDDATE" BIGINT,
		  "PORTLETTITLE" VARCHAR(256) ,
		PRIMARY KEY("ID")
);   


CREATE INDEX @DBSCHEMA@.IBMAN_IDX1 ON @DBSCHEMA@.IBMAN_ANNOTATION	("ANNOTATIONID" ASC);
CREATE INDEX @DBSCHEMA@.IBMAN_IDX2 ON @DBSCHEMA@.IBMAN_ANNOTATION	("CREATEDDATE" ASC);

-- ****************************UPGRADE*******************************************
-- This line is used for upgrading from WDF6.0.0 to WDF6.1 Beta. If the 
-- table IBMAN_ANNOTATION was created using the db2 script of WDF6.0.0, you should
-- run this line to upgrage the table. Otherwise you don't need to run this line
-- ******************************************************************************
-- ALTER TABLE IBMAN_ANNOTATION ADD "LASTMODIFIEDDATE" BIGINT

-----------------------------------------------------------------------------
-- ANNOTATION ATTACHMENT
-----------------------------------------------------------------------------
DROP TABLE @DBSCHEMA@.IBMAN_ATTACHMENTS;
CREATE TABLE @DBSCHEMA@.IBMAN_ATTACHMENTS(
		  "ID" BIGINT NOT NULL , 
		  "FILENAME" VARCHAR(256) NOT NULL , 
		  "EXTENSION" VARCHAR(256) , 
		  "ANNOTATIONID" BIGINT NOT NULL,
		  "DOCUMENTID" VARCHAR(256),
		PRIMARY KEY("ID"),
		FOREIGN KEY("ANNOTATIONID")
		REFERENCES @DBSCHEMA@.IBMAN_ANNOTATION("ID")ON DELETE CASCADE	ON UPDATE NO ACTION
);


CREATE INDEX @DBSCHEMA@.IBMAN_IDX4 ON @DBSCHEMA@.IBMAN_ATTACHMENTS("ANNOTATIONID" ASC);

-----------------------------------------------------------------------------
-- ANNOTATION DOCUMENT
-----------------------------------------------------------------------------
DROP TABLE @DBSCHEMA@.IBMAN_DOCUMENTS;
CREATE TABLE @DBSCHEMA@.IBMAN_DOCUMENTS(
		  "ID" BIGINT NOT NULL , 
		  "CONTENT" BLOB(1G),
		PRIMARY KEY("ID")
);

-----------------------------------------------------------------------------
-- ANNOTATION NOTIFIER
-----------------------------------------------------------------------------	
DROP TABLE @DBSCHEMA@.IBMAN_NOTIFIER;
CREATE TABLE @DBSCHEMA@.IBMAN_NOTIFIER  (
		  "USERID" VARCHAR(256) NOT NULL , 
		  "TYPE" INTEGER NOT NULL WITH DEFAULT 0 , 
		  "ANNOTATIONID" BIGINT NOT NULL , 
		  "ID" BIGINT NOT NULL ,
		PRIMARY KEY("ID"),
		FOREIGN KEY	("ANNOTATIONID")
	REFERENCES @DBSCHEMA@.IBMAN_ANNOTATION("ID")ON DELETE CASCADE ON UPDATE NO ACTION
		
);   

-----------------------------------------------------------------------------
-- ANNOTATION PRIVACY
-----------------------------------------------------------------------------
DROP TABLE @DBSCHEMA@.IBMAN_PRIVACY;
CREATE TABLE @DBSCHEMA@.IBMAN_PRIVACY(
		  "ID" BIGINT NOT NULL,
		  "USERID" VARCHAR(256) NOT NULL , 
		  "ISGROUP" INTEGER NOT NULL , 
		  "PERMISSION" INTEGER NOT NULL WITH DEFAULT 0 , 
		  "ANNOTATIONID" BIGINT NOT NULL ,
		PRIMARY KEY("ID"),	
		FOREIGN KEY("ANNOTATIONID")
	REFERENCES @DBSCHEMA@.IBMAN_ANNOTATION("ID")ON DELETE CASCADE ON UPDATE NO ACTION	  
);   


-----------------------------------------------------------------------------
-- ANNOTATION ARCHIVELOG
-----------------------------------------------------------------------------
DROP TABLE @DBSCHEMA@.IBMAN_ARCHIVELOG;
CREATE TABLE @DBSCHEMA@.IBMAN_ARCHIVELOG(
		  "ID" BIGINT NOT NULL , 
		  "STARTDATE" BIGINT NOT NULL , 
		  "ENDDATE" BIGINT NOT NULL , 
		  "FILEPATH" VARCHAR(1024) , 
		  "CREATOR" VARCHAR(256) NOT NULL ,
		  "CREATEDDATE" BIGINT NOT NULL , 
		  "DESCRIPTION" VARCHAR(512) ,
		PRIMARY KEY("ID")
)  ;


CREATE INDEX @DBSCHEMA@.IBMAN_IDX7 ON @DBSCHEMA@.IBMAN_ARCHIVELOG	("CREATEDDATE" ASC);




	

	





	
