CREATE SMALLFILE TABLESPACE "LAISPACE" DATAFILE '@DBRepLocation@/@DB_NAME@/LAISPACE' SIZE 64M AUTOEXTEND ON NEXT 50M MAXSIZE 2000M LOGGING EXTENT MANAGEMENT LOCAL SEGMENT SPACE MANAGEMENT AUTO;

create user "@DBSCHEMA@" profile "DEFAULT" identified by "@PASSWORD@" default tablespace "LAISPACE" temporary tablespace "TEMP" account unlock;

GRANT CONNECT TO @DBSCHEMA@;
GRANT CREATE SYNONYM TO @DBSCHEMA@;
GRANT ALTER SESSION TO @DBSCHEMA@;
GRANT CREATE SESSION TO @DBSCHEMA@;
ALTER USER @DBSCHEMA@ DEFAULT ROLE ALL;
GRANT ALTER TABLESPACE TO @DBSCHEMA@; 
GRANT UNLIMITED TABLESPACE TO @DBSCHEMA@; 

CREATE TABLE @DBSCHEMA@.Perspective (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Name varchar2(256) NOT NULL,
        Description varchar2(1024),
        Parent_OID NUMBER(19,0) DEFAULT NULL
);

CREATE TABLE @DBSCHEMA@.AuditTrail (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Owner_OID NUMBER(19,0),
        AUDIT_ACTION varchar2(32),
        ResourceType NUMBER(5,0),
        Subject_OID NUMBER(19,0) NOT NULL,
        New_Value varchar2(1024),
        Old_Value varchar2(1024),
        Field_Name varchar2(1024),
        Aux_OID NUMBER(19,0),
        Aux_INFO varchar2(1024)
) TABLESPACE USERS;

CREATE TABLE @DBSCHEMA@.Scorecard (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Owner_OID NUMBER(19,0) NOT NULL,
        Name varchar2(256) DEFAULT NULL,
        IsGroup NUMBER(5,0) DEFAULT 0,
        Category_OID NUMBER(19,0) DEFAULT NULL,
        Summary varchar2(1024) DEFAULT NULL,
        To_Be_Deleted NUMBER(5,0) DEFAULT 0    
);

CREATE TABLE @DBSCHEMA@.DataSource (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Name varchar2(256) NOT NULL,
        Description varchar2(1024),
        WSDL varchar2(1024),
        httpConfig varchar2(256),
        requestConfig varchar2(256),
        responseConfig varchar2(256),        
        Source_Attributes Blob
);

CREATE TABLE @DBSCHEMA@.DataSourceInstance (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        DataSource_OID NUMBER(19,0) NOT NULL,
        Instance_Attributes Blob
);

CREATE TABLE @DBSCHEMA@.Label (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Label_Key varchar2(128),
        Locale CHAR(5),
        Value varchar2(1024),
        DefaultValue varchar2(1024)
);

CREATE TABLE @DBSCHEMA@.Alert (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Alert_Type NUMBER(5,0) DEFAULT 1,
        OWNER_OID NUMBER(19,0),
        Msg_Key varchar2(64),
        Msg_Parameter_Values varchar2(1024),
        Subject_Key varchar2(64),
        Subject_Parameter_Values varchar2(512),
        State NUMBER(5,0) NOT NULL,
        ResourceType NUMBER(5,0) NOT NULL,
        Resource_OID NUMBER(19,0) NOT NULL,
        ResourceOwner_OID NUMBER(19,0) NOT NULL,
        Pending_Email	NUMBER(19,0)
);

CREATE TABLE @DBSCHEMA@.Principal (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        ExtUser varchar2(256) NOT NULL
);

CREATE TABLE @DBSCHEMA@.Hierarchy (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Attribute_Hierachy varchar2(254),
        Attribute_Unit_Name varchar2(254),
        Image_Small varchar2(256),
        Image_Large varchar2(256),
        Label_KEY varchar2(128),
        IsPrimary NUMBER(5,0),
        Ordinal NUMBER(5,0),
        Read_From NUMBER(5,0) DEFAULT 0,
        Attribute_Leaf_Unit_Name varchar2(254)
);

CREATE TABLE @DBSCHEMA@.UserAttribute (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Attribute varchar2(254),
        Label_KEY varchar2(128),
        Ordinal NUMBER(5,0)
);

CREATE TABLE @DBSCHEMA@.Execution(
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        To_Be_Deleted NUMBER(5,0),
        Scorecard_OID NUMBER(19,0) NOT NULL,
        Perspective_OID NUMBER(19,0),
        DataSource_Instance_OID NUMBER(19,0),
        Value_Type NUMBER(5,0) NOT NULL,
        RollUp_Type NUMBER(5,0) NOT NULL,
        Name varchar2(256) NOT NULL,
        Summary varchar2(1024),
        Mark NUMBER(5,0) DEFAULT -1,
        Actual BINARY_DOUBLE DEFAULT -1,
        ActionTime NUMBER(19,0),
        Last_Alerted_Trend NUMBER(5,0) DEFAULT -1,
        Last_Alerted_Status NUMBER(5,0) DEFAULT -1,
        Milestone NUMBER(5,0),
        Last_Alerted_MileStone NUMBER(19,0),
        Start_Time NUMBER(19,0) DEFAULT -1,
        Completion_Time NUMBER(19,0) NOT NULL,
        Resource_Type NUMBER(5,0),
        Has_TARGET NUMBER(5,0),
        STATE NUMBER(5,0) DEFAULT 1
);

CREATE TABLE @DBSCHEMA@.ExecutionMeasurement (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        EXECUTION_OID NUMBER(19,0) ,
        Ordinal NUMBER(5,0),
        ActionTime NUMBER(19,0),
        TARGETVALUE BINARY_DOUBLE
);

CREATE TABLE @DBSCHEMA@.ExecutionStatus (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        EXECUTION_OID NUMBER(19,0) NOT NULL,
        Status_Color NUMBER(5,0),
        Status_Zone NUMBER(5,0)
);

CREATE TABLE @DBSCHEMA@.ExecutionLinkage (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	Execution_OID NUMBER(19,0),
	Relationship varchar2(2048),
	Relationship_Type NUMBER(5,0),
	Start_Time NUMBER(19,0),
	Completion_Time NUMBER(19,0),
	Link_Type NUMBER(5,0),
	To_Be_Deleted NUMBER(5,0),
    Rollup_time NUMBER(19,0) 
);

CREATE TABLE @DBSCHEMA@.ExecutionAssociation (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	From_OID NUMBER(19,0),
	To_OID NUMBER(19,0),
	Link_Type NUMBER(5,0)
);

CREATE TABLE @DBSCHEMA@.ExecutionValue (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        EXECUTION_OID NUMBER(19,0) NOT NULL,
        ActionTime NUMBER(19,0) DEFAULT -1,
        Actual BINARY_DOUBLE DEFAULT -1
);

CREATE TABLE @DBSCHEMA@.MeasurementTemplate (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	Name varchar2(256),
	Description varchar2(1024),
	Category_OID NUMBER(19,0)
);

CREATE TABLE @DBSCHEMA@.MeasurementTemplateCategory (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	Name varchar2(512) NOT NULL,
	Description varchar2(1024)
);

CREATE TABLE @DBSCHEMA@.MeasurementTemplateValue (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	MT_OID NUMBER(19,0),
	ORDINAL NUMBER(5,0),
	TIMEUNIT NUMBER(5,0),
	FORMULA varchar2(512)
);

CREATE TABLE @DBSCHEMA@.MeasurementTemplateStatus (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	MT_OID NUMBER(19,0),
	MT_COLOR NUMBER(5,0),
	MT_ZONE NUMBER(5,0)
);

CREATE TABLE @DBSCHEMA@.ScheduleActionTime (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Action_Time NUMBER(19,0),
        Status NUMBER(5,0),
        CountNum NUMBER(19,0),
        RollUpTime NUMBER(19,0)
);

CREATE TABLE @DBSCHEMA@.WebResource (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        EXECUTION_OID NUMBER(19,0) NOT NULL,
        Resource_Name varchar2(256),
        URL varchar2(1024),
        Type NUMBER(5,0),
        Display_Type NUMBER(5,0),
        Favorite NUMBER(5,0)
);

CREATE TABLE @DBSCHEMA@.GlobalSetting (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        SETTINGKEY varchar2(32),
        Value varchar2(256)
);

CREATE TABLE @DBSCHEMA@.WBPM_ID_TABLE (
        RES_TYPE NUMBER(5,0) NOT NULL,
        LAST_OID NUMBER(19,0) NOT NULL,
        LOCAL_PID NUMBER(10,0)
);

CREATE TABLE @DBSCHEMA@.WBPM_GUPID_DESC (
        LOCAL_PID NUMBER(10,0) DEFAULT 0 NOT NULL,
        GUPID CHAR(20) NOT NULL,
        STATE CHAR(1) DEFAULT 'O' NOT NULL
);

CREATE TABLE @DBSCHEMA@.Actn (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Action_Name varchar2(64) NOT NULL,
        Description varchar2(1024)
        );

CREATE TABLE @DBSCHEMA@.ActionSet (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Action_Set_Name varchar2(256) NOT NULL,
        Description varchar2(1024)
        );

CREATE TABLE @DBSCHEMA@.ActionSetAction (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Action_Set_OID NUMBER(19,0),
        Action_OID NUMBER(19,0)
        );

CREATE TABLE @DBSCHEMA@.ActionResourceType (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Resource_Type NUMBER(5,0),
        Action_OID  NUMBER(19,0)
        );

CREATE TABLE @DBSCHEMA@.ResourcePolicy (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Resource_Type NUMBER(5,0) NOT NULL,
        Action_Set_OID NUMBER(19,0) NOT NULL,
        Start_Level NUMBER(5,0),
        End_Level NUMBER(5,0)
        );

CREATE TABLE @DBSCHEMA@.ResourceInstancePolicy (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Resource_Type NUMBER(5,0) NOT NULL,
        Resource_OID NUMBER(19,0) NOT NULL,
        Action_Set_OID NUMBER(19,0) NOT NULL,
        Start_Level NUMBER(5,0),
        End_Level NUMBER(5,0)
        );

CREATE TABLE @DBSCHEMA@.ResourceUserPolicy (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Operation NUMBER(5,0),
        USER_ID NUMBER(19,0) NOT NULL,
        Action_Set_OID NUMBER(19,0) NOT NULL,
        Resource_Type NUMBER(5,0) NOT NULL
        );

CREATE TABLE @DBSCHEMA@.ResourceInstanceUserPolicy (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Operation NUMBER(5,0),
        USER_ID NUMBER(19,0) NOT NULL,
        Action_Set_OID NUMBER(19,0) NOT NULL,
        Resource_OID NUMBER(19,0) NOT NULL,
    	Resource_Type NUMBER(5,0) NOT NULL
        );

CREATE TABLE @DBSCHEMA@.Task (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	Name varchar2(256) NOT NULL,
	Class varchar2(512),
	Type NUMBER(5,0)
);

CREATE TABLE @DBSCHEMA@.AsyncEvent (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	WASTaskID NUMBER(19,0),
	Name varchar2(128),
	Class varchar2(128),
	Status NUMBER(5,0),
	Freq NUMBER(5,0),
	LastStartDate NUMBER(19,0),
	LastEndDate NUMBER(19,0),
	Stop NUMBER(5,0),
	Updated NUMBER(19,0),
	CurrentTask varchar2(512),
	Success NUMBER(5,0),
	Independence NUMBER(5,0)
);

CREATE TABLE @DBSCHEMA@.EventTask (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	AsyncEvent_OID NUMBER(19,0),
	Task_OID NUMBER(19,0),
	Param varchar2(1024),
	Ordinal NUMBER(5,0),
	LastStartDate NUMBER(19,0),
	LastEndDate NUMBER(19,0),
	Stop NUMBER(5,0),
	Updated NUMBER(19,0),
	Message varchar2(512)
);

CREATE TABLE @DBSCHEMA@.TaskLog (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	EventTask_OID NUMBER(19,0),
	Progress BINARY_DOUBLE,
	StartDate NUMBER(19,0),
	EndDate NUMBER(19,0),
	Status NUMBER(5,0),
	Message varchar2(512)
);

CREATE TABLE @DBSCHEMA@.TaskLogDetail (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	TaskLog_OID NUMBER(19,0),
	Message varchar2(1024)
);

CREATE TABLE @DBSCHEMA@.SecurityConf (
	OID NUMBER(19,0) NOT NULL,
	Created NUMBER(19,0) NOT NULL,
	Modified NUMBER(19,0) DEFAULT NULL,
	Name varchar2(256),
	Description varchar2(1024),
	Conf_Attr BLOB,
	SecurityConf_Type NUMBER(5,0)
);

CREATE TABLE @DBSCHEMA@.ExecutionShare (
        OID           NUMBER(19,0) NOT NULL,
        Created       NUMBER(19,0) NOT NULL,
        Modified      NUMBER(19,0) DEFAULT NULL,
        Execution_OID NUMBER(19,0) NOT NULL,
        Scorecard_OID NUMBER(19,0) NOT NULL
);

CREATE TABLE @DBSCHEMA@.ScorecardCategory (
        OID NUMBER(19,0) NOT NULL,
        Created NUMBER(19,0) NOT NULL,
        Modified NUMBER(19,0) DEFAULT NULL,
        Name varchar2(256) NOT NULL,
        Parent_OID NUMBER(19,0) DEFAULT NULL
);

CREATE TABLE @DBSCHEMA@.ExecutionCategory (
        OID        NUMBER(19,0) NOT NULL,
        Created    NUMBER(19,0) NOT NULL,
        Modified   NUMBER(19,0) DEFAULT NULL,
        Name       varchar2(256) NOT NULL,
        Owner_OID  NUMBER(19,0) NOT NULL,
        Parent_OID NUMBER(19,0) DEFAULT NULL
);

CREATE TABLE @DBSCHEMA@.ExecutionCategoryAssociation (
        OID           NUMBER(19,0) NOT NULL,
        Created       NUMBER(19,0) NOT NULL,
        Modified      NUMBER(19,0) DEFAULT NULL,
        Execution_OID NUMBER(19,0) NOT NULL,
        Category_OID  NUMBER(19,0) NOT NULL
);

CREATE TABLE @DBSCHEMA@.FavoriteScorecard (
		OID 			NUMBER(19,0) NOT NULL,
		Created			NUMBER(19,0) NOT NULL,
		Modified 		NUMBER(19,0) DEFAULT NULL,
		Owner_OID 		NUMBER(19,0) NOT NULL,
		Scorecard_OID	NUMBER(19,0) NOT NULL
);

CREATE CLUSTER @DBSCHEMA@.TASK_CLUSTER("NEXTFIRETIME" NUMBER(19,0), "REPEATSLEFT" NUMBER(10,0), "PARTITIONID" NUMBER(10,0))  SIZE 5355 TABLESPACE "LAISPACE" INDEX STORAGE (initial 5000K next 1000K);
CREATE INDEX "LWPTASK_IDX2" ON CLUSTER @DBSCHEMA@.TASK_CLUSTER;

CREATE TABLE @DBSCHEMA@.LWPTASK
(
          "TASKID"                     NUMBER(19,0)             NOT NULL ,
          "VERSION"                    varchar2(5)         NOT NULL ,
          "ROW_VERSION"                NUMBER(10,0)            NOT NULL ,
          "TASKTYPE"                   NUMBER(10,0)            NOT NULL ,
          "TASKSUSPENDED"              NUMBER(5,0)           NOT NULL ,
          "CANCELLED"                  NUMBER(5,0)           NOT NULL ,
          "NEXTFIRETIME"               NUMBER(19,0)             NOT NULL ,
          "STARTBYINTERVAL"            varchar2(254)        ,
          "STARTBYTIME"                NUMBER(19,0)              ,
          "VALIDFROMTIME"              NUMBER(19,0)              ,
          "VALIDTOTIME"                NUMBER(19,0)              ,
          "REPEATINTERVAL"             varchar2(254)        ,
          "MAXREPEATS"                 NUMBER(10,0)            NOT NULL ,
          "REPEATSLEFT"                NUMBER(10,0)            NOT NULL ,
          "TASKINFO"                   BLOB    ,
          "NAME"                       varchar2(254)       NOT NULL ,
          "AUTOPURGE"                  NUMBER(10,0)            NOT NULL ,
          "FAILUREACTION"              NUMBER(10,0)             ,
          "MAXATTEMPTS"                NUMBER(10,0)             ,
          "QOS"                        NUMBER(10,0)             ,
          "PARTITIONID"                NUMBER(10,0)             ,
          "OWNERTOKEN"                 varchar2(200)       NOT NULL ,
          "CREATETIME"                 NUMBER(19,0)             NOT NULL
);
--CLUSTER @DBSCHEMA@.TASK_CLUSTER("NEXTFIRETIME","REPEATSLEFT","PARTITIONID");

ALTER TABLE @DBSCHEMA@.LWPTASK ADD PRIMARY KEY ("TASKID");

CREATE INDEX "LWPTASK_IDX1"
  ON @DBSCHEMA@.LWPTASK
(
    "TASKID","OWNERTOKEN"
);

CREATE TABLE @DBSCHEMA@.LWPTREG
(
    "REGKEY"                       varchar2(254)         NOT NULL ,
    "REGVALUE"                     varchar2(254)
);

ALTER TABLE @DBSCHEMA@.LWPTREG ADD PRIMARY KEY ("REGKEY");

CREATE TABLE @DBSCHEMA@.LWPLMGR
(
        LEASENAME                      varchar2(254) NOT NULL,
        LEASEOWNER                     varchar2(254) NOT NULL,
        LEASE_EXPIRE_TIME              NUMBER(19,0),
        DISABLED                       varchar2(5)
);

ALTER TABLE @DBSCHEMA@.LWPLMGR ADD PRIMARY KEY ("LEASENAME");

CREATE TABLE @DBSCHEMA@.LWPLMPR
(
        LEASENAME                      varchar2(254) NOT NULL,
        NAME                           varchar2(254) NOT NULL,
        VALUE                          varchar2(254) NOT NULL
);

CREATE INDEX "LWPLMPR_IDX1" ON @DBSCHEMA@.LWPLMPR
(
        LEASENAME, NAME
);


---------------------------------------------------------------------------------------------------------
-- Define Primary Key
---------------------------------------------------------------------------------------------------------

ALTER TABLE @DBSCHEMA@.Perspective ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.AuditTrail ADD PRIMARY KEY(OID);

ALTER TABLE @DBSCHEMA@.Scorecard ADD PRIMARY KEY (OID);


ALTER TABLE @DBSCHEMA@.Execution
        ADD UNIQUE (
                Name,
                Scorecard_OID,
                Completion_Time
            );

ALTER TABLE @DBSCHEMA@.DataSource ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.DataSourceInstance ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.Label ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.Alert ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.Principal ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.Principal ADD UNIQUE (ExtUser);

ALTER TABLE @DBSCHEMA@.Hierarchy ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.UserAttribute ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.Execution ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ExecutionMeasurement ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ExecutionStatus ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ExecutionLinkage ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ExecutionAssociation ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ExecutionValue ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.MeasurementTemplate ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.MeasurementTemplateValue  ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.MeasurementTemplateStatus ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ScheduleActionTime ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.WebResource ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.GlobalSetting ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.WBPM_ID_TABLE ADD PRIMARY KEY (RES_TYPE);

ALTER TABLE @DBSCHEMA@.Actn ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ActionSet ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ActionSetAction ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ActionResourceType ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ResourcePolicy ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ResourceInstancePolicy ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ResourceUserPolicy ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ResourceInstanceUserPolicy ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.Task ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.Task ADD UNIQUE (Name);

ALTER TABLE @DBSCHEMA@.AsyncEvent ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.EventTask ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.TaskLog ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.TaskLogDetail ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.SecurityConf ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.MeasurementTemplateCategory ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ExecutionShare ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ExecutionCategory ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ExecutionCategoryAssociation ADD PRIMARY KEY (OID);

---------------------------------------------------------------------------------------------------------
-- Create Foreign Key
---------------------------------------------------------------------------------------------------------

ALTER TABLE @DBSCHEMA@.Perspective
        ADD FOREIGN KEY (
                Parent_OID
                )
        REFERENCES @DBSCHEMA@.Perspective (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.DataSourceInstance
        ADD FOREIGN KEY (
                DataSource_OID
                )
        REFERENCES @DBSCHEMA@.DataSource (
                OID
                ) DISABLE;


ALTER TABLE @DBSCHEMA@.Execution
        ADD FOREIGN KEY (
                Scorecard_OID
                )
        REFERENCES @DBSCHEMA@.Scorecard (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.Execution
        ADD FOREIGN KEY (
                Perspective_OID
                )
        REFERENCES @DBSCHEMA@.Perspective (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.Execution
        ADD FOREIGN KEY (
                DataSource_Instance_OID
                )
        REFERENCES @DBSCHEMA@.DataSourceInstance (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.ExecutionMeasurement
	ADD FOREIGN KEY (
		EXECUTION_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.ExecutionStatus
        ADD FOREIGN KEY (
                EXECUTION_OID
                )
        REFERENCES @DBSCHEMA@.Execution (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.ExecutionLinkage
	ADD FOREIGN KEY (
		Execution_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.ExecutionAssociation
	ADD FOREIGN KEY (
		From_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.ExecutionValue
        ADD FOREIGN KEY (
                EXECUTION_OID
                )
        REFERENCES @DBSCHEMA@.Execution (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.MeasurementTemplateValue 
	ADD FOREIGN KEY (
		MT_OID
	)
	REFERENCES @DBSCHEMA@.MeasurementTemplate (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.MeasurementTemplateStatus 
	ADD FOREIGN KEY (
		MT_OID
	)
	REFERENCES @DBSCHEMA@.MeasurementTemplate (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.WebResource
        ADD FOREIGN KEY (
                EXECUTION_OID
                )
        REFERENCES @DBSCHEMA@.Execution (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.ActionSetAction
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.ActionSetAction
        ADD FOREIGN KEY (
                Action_OID
                )
        REFERENCES @DBSCHEMA@.Actn (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.ActionResourceType
        ADD FOREIGN KEY (
                Action_OID
                )
        REFERENCES @DBSCHEMA@.Actn (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.ResourcePolicy
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.ResourcePolicy
        ADD UNIQUE (
                Resource_Type, Action_Set_OID
                );

ALTER TABLE @DBSCHEMA@.ResourceInstancePolicy
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.ResourceInstancePolicy
        ADD UNIQUE (
                Resource_Type, Resource_OID, Action_Set_OID
                );

ALTER TABLE @DBSCHEMA@.ResourceUserPolicy
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                ) DISABLE;

ALTER TABLE @DBSCHEMA@.ResourceUserPolicy
        ADD UNIQUE (
                USER_ID, Action_Set_OID, Resource_Type
                );

ALTER TABLE @DBSCHEMA@.ResourceInstanceUserPolicy
        ADD UNIQUE (
                USER_ID, Action_Set_OID, Resource_OID, Resource_Type
                );

ALTER TABLE @DBSCHEMA@.ResourceInstanceUserPolicy
        ADD FOREIGN KEY (
                Action_Set_OID
                )
        REFERENCES @DBSCHEMA@.ActionSet (
                OID
                ) DISABLE;


ALTER TABLE @DBSCHEMA@.EventTask
	ADD FOREIGN KEY (
		AsyncEvent_OID
	)
	REFERENCES @DBSCHEMA@.AsyncEvent (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.EventTask
	ADD FOREIGN KEY (
		Task_OID
	)
	REFERENCES @DBSCHEMA@.Task (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.TaskLog
	ADD FOREIGN KEY (
		EventTask_OID
	)
	REFERENCES @DBSCHEMA@.EventTask (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.TaskLogDetail
	ADD FOREIGN KEY (
		TaskLog_OID
	)
	REFERENCES @DBSCHEMA@.TaskLog (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.MeasurementTemplate
	ADD FOREIGN KEY (
		Category_OID
	)
	REFERENCES @DBSCHEMA@.MeasurementTemplateCategory (
		OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.MeasurementTemplateCategory ADD UNIQUE (Name);

ALTER TABLE @DBSCHEMA@.ScorecardCategory ADD PRIMARY KEY (OID);

ALTER TABLE @DBSCHEMA@.ExecutionShare
	ADD FOREIGN KEY (
		Scorecard_OID
	)
	REFERENCES @DBSCHEMA@.Scorecard (
    	OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.ExecutionShare
	ADD FOREIGN KEY (
    	Execution_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
    	OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.ExecutionCategoryAssociation
	ADD FOREIGN KEY (
    	Execution_OID
	)
	REFERENCES @DBSCHEMA@.Execution (
    	OID
	) DISABLE;

ALTER TABLE @DBSCHEMA@.ExecutionCategoryAssociation
	ADD FOREIGN KEY (
    	Category_OID
	)
	REFERENCES @DBSCHEMA@.ExecutionCategory (
    	OID
	) DISABLE;

---------------------------------------------------------------------------------------------------------
-- Create Index
---------------------------------------------------------------------------------------------------------

CREATE INDEX @DBSCHEMA@.ALERT_IDX1 ON @DBSCHEMA@.ALERT (ALERT_TYPE, OWNER_OID);

CREATE INDEX ALERT_IDX2 ON @DBSCHEMA@.ALERT (OWNER_OID);

CREATE INDEX AUDITRAIL_IDX1 ON @DBSCHEMA@.AUDITTRAIL (OWNER_OID) ;

CREATE INDEX AUDITTRAIL_IDX2 ON @DBSCHEMA@.AUDITTRAIL (RESOURCETYPE, SUBJECT_OID);
      
CREATE INDEX DSI_IDX ON @DBSCHEMA@.DATASOURCEINSTANCE (DATASOURCE_OID);
      
CREATE  INDEX @DBSCHEMA@.EXE_IDX1 ON @DBSCHEMA@.EXECUTION (SCORECARD_OID);

CREATE  INDEX @DBSCHEMA@.EXE_IDX2 ON @DBSCHEMA@.EXECUTION (RESOURCE_TYPE);

CREATE  INDEX @DBSCHEMA@.EXE_IDX3 ON @DBSCHEMA@.EXECUTION (START_TIME);

CREATE  INDEX EXE_IDX4 ON @DBSCHEMA@.EXECUTION (SCORECARD_OID, PERSPECTIVE_OID);
      
CREATE  INDEX EXE_IDX5 ON @DBSCHEMA@.EXECUTION (SCORECARD_OID, NAME);
      
CREATE  INDEX EXE_IDX ON @DBSCHEMA@.EXECUTION (DATASOURCE_INSTANCE_OID);

CREATE  INDEX LINKAGE_IDX1 ON @DBSCHEMA@.EXECUTIONLINKAGE (EXECUTION_OID);

CREATE  INDEX LINKAGE_IDX2 ON @DBSCHEMA@.EXECUTIONLINKAGE (TO_BE_DELETED);

CREATE  INDEX LINKAGE_IDX3 ON @DBSCHEMA@.EXECUTIONLINKAGE (LINK_TYPE);
      
CREATE  INDEX LINKAGE_IDX4 ON @DBSCHEMA@.EXECUTIONLINKAGE (EXECUTION_OID, RELATIONSHIP_TYPE);      

CREATE  INDEX LINKAGE_IDX5 ON @DBSCHEMA@.EXECUTIONLINKAGE (EXECUTION_OID, START_TIME, COMPLETION_TIME);
             
CREATE  INDEX MEA_IDX2 ON @DBSCHEMA@.EXECUTIONMEASUREMENT (EXECUTION_OID);
            
CREATE  INDEX @DBSCHEMA@.STATUS_IDX1 ON @DBSCHEMA@.EXECUTIONSTATUS (EXECUTION_OID);
      
CREATE  INDEX @DBSCHEMA@.VALUE_IDX1 ON @DBSCHEMA@.EXECUTIONVALUE (EXECUTION_OID);
           
CREATE  INDEX RIP_IDX1 ON @DBSCHEMA@.RESOURCEINSTANCEPOLICY (ACTION_SET_OID);

CREATE  INDEX RIP_IDX2 ON @DBSCHEMA@.RESOURCEINSTANCEPOLICY (RESOURCE_TYPE, RESOURCE_OID);  
      
CREATE  INDEX RIUP_IDX1 ON @DBSCHEMA@.RESOURCEINSTANCEUSERPOLICY (USER_ID) ;

CREATE  INDEX RIUP_IDX2 ON @DBSCHEMA@.RESOURCEINSTANCEUSERPOLICY (ACTION_SET_OID);

CREATE  INDEX RIUP_IDX3 ON @DBSCHEMA@.RESOURCEINSTANCEUSERPOLICY (RESOURCE_OID, RESOURCE_TYPE);
      
CREATE  INDEX WEBRESOURCE_IDX ON @DBSCHEMA@.WEBRESOURCE (EXECUTION_OID);
           
CREATE  INDEX ASSOCIATION_IDX1 ON @DBSCHEMA@.EXECUTIONASSOCIATION (FROM_OID);
      
CREATE  INDEX ASSOCIATION_IDX2 ON @DBSCHEMA@.EXECUTIONASSOCIATION (FROM_OID, LINK_TYPE);
      
CREATE  INDEX ASSOCIATION_IDX3 ON @DBSCHEMA@.EXECUTIONASSOCIATION (TO_OID, LINK_TYPE);
      
CREATE  INDEX ASYNCEVENT_IDX1 ON @DBSCHEMA@.ASYNCEVENT (WASTaskID);
      
CREATE INDEX ES_IDX1 ON @DBSCHEMA@.ExecutionShare (Scorecard_OID);

CREATE INDEX ES_IDX2 ON @DBSCHEMA@.ExecutionShare (Execution_OID);

CREATE INDEX EC_IDX1 ON @DBSCHEMA@.ExecutionCategory (Owner_OID);

CREATE INDEX ECA_IDX1 ON @DBSCHEMA@.ExecutionCategoryAssociation (Execution_OID);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX1 ON @DBSCHEMA@.SCORECARD (IsGroup,To_Be_Deleted);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX2 ON @DBSCHEMA@.SCORECARD (IsGroup,name);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX3 ON @DBSCHEMA@.SCORECARD (IsGroup,Owner_OID);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX4 ON @DBSCHEMA@.SCORECARD (Owner_OID);

CREATE  INDEX @DBSCHEMA@.SCORECARD_IDX5 ON @DBSCHEMA@.SCORECARD (Category_OID);


-----------------------------------------------------------------------------
-- ANNOTATION
-----------------------------------------------------------------------------
CREATE SEQUENCE @DBSCHEMA@.IBMAN_IDSEQ
	START WITH 1
	INCREMENT BY 1
	MINVALUE 1
	NOMAXVALUE
	NOCYCLE
	NOCACHE
	NOORDER;
 
CREATE TABLE @DBSCHEMA@.IBMAN_ANNOTATION (
		  "ID" NUMBER(19,0) NOT NULL , 
		  "ANNOTATIONID" varchar2(512) NOT NULL , 
		  "CONTENT" CLOB, 
		  "AUTHOR" varchar2(256) NOT NULL , 
		  "PARENT" NUMBER(19,0) , 
		  "TITLE" varchar2(1024), 
		  "TABLEID" varchar2(512) , 
		  "TYPE" NUMBER(10,0) , 
		  "ATTACHMENTSDIR" varchar2(256) , 
		  "ENABLEPRIVACY" NUMBER(10,0) DEFAULT 0 NOT NULL, 
		  "CREATEDDATE" NUMBER(19,0) NOT NULL ,
		  "LASTMODIFIEDDATE" NUMBER(19,0),
		  "PORTLETTITLE" varchar2(256) ,
		PRIMARY KEY("ID")
);   

CREATE INDEX @DBSCHEMA@.IBMAN_IDX1 ON @DBSCHEMA@.IBMAN_ANNOTATION	("ANNOTATIONID" ASC);
CREATE INDEX @DBSCHEMA@.IBMAN_IDX2 ON @DBSCHEMA@.IBMAN_ANNOTATION	("CREATEDDATE" ASC);

-----------------------------------------------------------------------------
-- ANNOTATION ATTACHMENT
-----------------------------------------------------------------------------

CREATE TABLE @DBSCHEMA@.IBMAN_ATTACHMENTS(
		  "ID" NUMBER(19,0) NOT NULL , 
		  "FILENAME" varchar2(256) NOT NULL , 
		  "EXTENSION" varchar2(256) , 
		  "ANNOTATIONID" NUMBER(19,0) NOT NULL,
		  "DOCUMENTID" varchar2(256),
		PRIMARY KEY("ID"),
		FOREIGN KEY("ANNOTATIONID")
		REFERENCES @DBSCHEMA@.IBMAN_ANNOTATION("ID") ON DELETE CASCADE
);

CREATE INDEX @DBSCHEMA@.IBMAN_IDX4 ON @DBSCHEMA@.IBMAN_ATTACHMENTS("ANNOTATIONID" ASC);

-----------------------------------------------------------------------------
-- ANNOTATION DOCUMENT
-----------------------------------------------------------------------------
CREATE TABLE @DBSCHEMA@.IBMAN_DOCUMENTS(
		  "ID" NUMBER(19,0) NOT NULL , 
		  "CONTENT" BLOB,
		PRIMARY KEY("ID")
);

-----------------------------------------------------------------------------
-- ANNOTATION NOTIFIER
-----------------------------------------------------------------------------	

CREATE TABLE @DBSCHEMA@.IBMAN_NOTIFIER  (
		  "USERID" varchar2(256) NOT NULL , 
		  "TYPE" NUMBER(10,0) DEFAULT 0 NOT NULL, 
		  "ANNOTATIONID" NUMBER(19,0) NOT NULL , 
		  "ID" NUMBER(19,0) NOT NULL ,
		PRIMARY KEY("ID"),
		FOREIGN KEY	("ANNOTATIONID")
	REFERENCES @DBSCHEMA@.IBMAN_ANNOTATION("ID") ON DELETE CASCADE 
);   

-----------------------------------------------------------------------------
-- ANNOTATION PRIVACY
-----------------------------------------------------------------------------
CREATE TABLE @DBSCHEMA@.IBMAN_PRIVACY(
		  "ID" NUMBER(19,0) NOT NULL,
		  "USERID" varchar2(256) NOT NULL , 
		  "ISGROUP" NUMBER(10,0) NOT NULL , 
		  "PERMISSION" NUMBER(10,0) DEFAULT 0 NOT NULL, 
		  "ANNOTATIONID" NUMBER(19,0) NOT NULL ,
		PRIMARY KEY("ID"),	
		FOREIGN KEY("ANNOTATIONID")
	REFERENCES @DBSCHEMA@.IBMAN_ANNOTATION("ID")ON DELETE CASCADE   
);   


-----------------------------------------------------------------------------
-- ANNOTATION ARCHIVELOG
-----------------------------------------------------------------------------
CREATE TABLE @DBSCHEMA@.IBMAN_ARCHIVELOG(
		  "ID" NUMBER(19,0) NOT NULL , 
		  "STARTDATE" NUMBER(19,0) NOT NULL , 
		  "ENDDATE" NUMBER(19,0) NOT NULL , 
		  "FILEPATH" varchar2(1024) , 
		  "CREATOR" varchar2(256) NOT NULL ,
		  "CREATEDDATE" NUMBER(19,0) NOT NULL , 
		  "DESCRIPTION" varchar2(512) ,
		PRIMARY KEY("ID")
);

CREATE INDEX @DBSCHEMA@.IBMAN_IDX7 ON @DBSCHEMA@.IBMAN_ARCHIVELOG	("CREATEDDATE" ASC);

--------------------- insert data

@@SCRIPT@/WBPM_Id.sql;
@@SCRIPT@/globalsettings.sql;
@@SCRIPT@/acl.sql;
@@SCRIPT@/fixedtasks.sql;
@@SCRIPT@/mt_status.sql;
@@SCRIPT@/mt_value.sql;

commit;
quit;
